#property copyright "Copyright  2005, klot"
#property link      "klot@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern int Risk = 5;
extern int CandleTF = 240;
extern bool AlertOn = TRUE;
extern bool EmailOn = FALSE;
double gda_92[];
double gda_96[];
int gia_100[];
int gi_104 = 0;

int init() {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 159);
   SetIndexBuffer(0, gda_92);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 159);
   SetIndexBuffer(1, gda_96);
   SetIndexEmptyValue(1, 0.0);
   if (Period() > CandleTF) {
      Alert("DT-ZigZag: Please set to a higher TF ", CandleTF);
      return (0);
   }
   ArrayCopySeries(gia_100, 5, Symbol(), CandleTF);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int li_0;
   double ld_4;
   int li_12 = IndicatorCounted();
   int li_16 = 300;
   if (li_12 < 0) return (-1);
   if (li_12 > 0) li_12--;
   li_16 = Bars - li_12;
   for (int li_20 = 0; li_20 < li_16; li_20++) {
      if (Time[li_20] >= gia_100[0]) li_0 = 0;
      else {
         li_0 = ArrayBsearch(gia_100, Time[li_20 - 1], WHOLE_ARRAY, 0, MODE_DESCEND);
         if (Period() <= CandleTF) li_0++;
      }
      for (int li_24 = li_0; li_24 < li_0 + 100; li_24++) {
         ld_4 = iCustom(NULL, CandleTF, "ZigZag", Risk, 5, 3, 0, li_24 + 1);
         if (ld_4 != 0.0) break;
      }
      if (iClose(NULL, 0, li_20 + 1) <= ld_4) gda_96[li_20] = ld_4;
      else gda_96[li_20] = 0.0;
      if (iClose(NULL, 0, li_20 + 1) >= ld_4) gda_92[li_20] = ld_4;
      else gda_92[li_20] = 0.0;
      ObjectsRedraw();
   }
   if (gda_92[1] > 0.0 && gi_104 < 1) {
      if (AlertOn) Alert("Buy Alert on " + Symbol() + "[" + Period() + "m]");
      if (EmailOn) SendMail("Buy Alert!", "Buy alert on " + Symbol() + "[" + Period() + "m]");
      gi_104 = 1;
   } else {
      if (gda_96[1] > 0.0 && gi_104 > -1) {
         if (AlertOn) Alert("Sell Alert on " + Symbol() + "[" + Period() + "m]");
         if (EmailOn) SendMail("Sell Alert!", "Sell alert on " + Symbol() + "[" + Period() + "m]");
         gi_104 = -1;
      }
   }
   return (0);
}